// DragDropEdit.cpp : implementation file
//

#include "stdafx.h"
#include <afxole.h>         // MFC OLE classes
#include <afxdisp.h >       // MFC OLE automation classes
#include <afxodlgs.h>       // MFC OLE dialog classes
#include <afxpriv.h>



#include "FileDate.h"
#include "DragDropEdit.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNAMIC(CDragDropEdit, CEdit)	//	Want info for drag

#define	EDITBOX_EVENT		2
#define	EDITBOX_EVENT_TIME	100

#define	MINIMUM_MOVE_SQUARE	100	//	10 pixels
/////////////////////////////////////////////////////////////////////////////
// CDragDropEdit

CDragDropEdit::CDragDropEdit()
{
	//m_StartPoint = CPoint(-1, -1);

	m_TargetDrop = new ECOleMemDropTarget();
}

CDragDropEdit::~CDragDropEdit()
{
	
}

BEGIN_MESSAGE_MAP(CDragDropEdit, CEdit)
	//{{AFX_MSG_MAP(CDragDropEdit)
	ON_WM_DESTROY()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CDragDropEdit::InitDragDrop()
{
	if(m_TargetDrop)
		m_TargetDrop->Register(this, CF_HDROP);
}

void CDragDropEdit::OnDestroy() 
{
	if(m_TargetDrop)
	{
		//	stop drag and drop
		m_TargetDrop->Revoke();

		//	KILL!
		delete m_TargetDrop;
	}
	m_TargetDrop = NULL;

	CEdit::OnDestroy();
}
void CDragDropEdit::OnMouseMove(UINT nFlags, CPoint point) 
{
	if(m_btnDown)
	{
		m_btnDown = false;
		COleDataSource*	pSource = new COleDataSource();
		if(pSource)
		{
			CSharedFile	sf(GMEM_MOVEABLE|GMEM_DDESHARE|GMEM_ZEROINIT);
			CString cszText,cszTmp;

			//	lets move our text
			GetWindowText(cszTmp);

			cszText = cszTmp.Mid(m_nSelStart,m_nSelEnd-m_nSelStart);
			
			//	wanne move something (and have mem)
			if(cszText.GetLength())
			{
				//	write name to clipboard
				sf.Write(cszText, cszText.GetLength());

				HGLOBAL hMem = sf.Detach();
				if (!hMem) 
					return;
				pSource->CacheGlobalData(CF_TEXT, hMem);

				//	Do drag and drop!
				pSource->DoDragDrop();
			}
			//	free source
			delete pSource;
		}
	}
	CEdit::OnMouseMove(nFlags, point);
}

void CDragDropEdit::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CPoint pt1, pt2;
	GetSel(m_nSelStart,m_nSelEnd);
	if((m_nSelEnd > 0)&&(m_nSelStart != m_nSelEnd))
	{
		pt1 = PosFromChar(m_nSelStart);
		pt2 = PosFromChar(m_nSelEnd-1);

		if((point.x > pt1.x)&&(point.x < pt2.x))
		{
			if(!m_btnDown)
			{
				m_btnDown = true;
				return;
			}
		}
	}
	CEdit::OnLButtonDown(nFlags, point);
}

void CDragDropEdit::OnLButtonUp(UINT nFlags, CPoint point) 
{
	m_btnDown = false;
	
	CEdit::OnLButtonUp(nFlags, point);
}
